<script setup lang="ts">
import { ref } from 'vue'

import { type Product } from '@/types/Product'

import ProductList from '@/components/ProductList.vue'
import { useReceiptStore } from '@/stores/receipt'
import ReceiptDetailTable from './ReceiptDetailTable.vue'
import ReceiptCard from './ReceiptCard.vue'
import MemberCard from './MemberCard.vue'
import ReceiptDialogVue from './ReceiptDialog.vue'
import QrCodeDialog from './QrCodeDialog.vue'
import ErrorCashDialog from './ErrorCashDialog.vue'
import ErrorDialog from './ErrorDialog.vue'

import { nextTick } from 'vue'
import { provide } from 'vue'

const dialog = ref(false)
provide('receiptDialog', dialog)

const receiptStore = useReceiptStore()

const products1: Product[] = [
  { id: 1, name: 'Mocca', price: 40.0, type: 1 },
  { id: 2, name: 'Capuchino', price: 45.0, type: 1 },
  { id: 3, name: 'Latte', price: 40.0, type: 1 },
  { id: 4, name: 'Coacoa', price: 40.0, type: 1 },
  { id: 5, name: 'Chocolate', price: 50.0, type: 1 },
  { id: 6, name: 'Americano', price: 50.0, type: 1 },
  { id: 7, name: 'Matcha Latte', price: 50.0, type: 1 },
  { id: 8, name: 'Thai tea', price: 50.0, type: 1 },
  { id: 9, name: 'Black coffee', price: 50.0, type: 1 }
]

const products2: Product[] = [
  { id: 10, name: 'Cookie', price: 25.0, type: 2 },
  { id: 11, name: 'Brownie', price: 35.0, type: 2 },
  { id: 12, name: 'Crape Roll', price: 25.0, type: 2 },
  { id: 13, name: 'Toast strawberry', price: 20.0, type: 2 },
  { id: 14, name: 'Croissant', price: 45.0, type: 2 }
]

const products3: Product[] = [
  { id: 15, name: 'Chocolate cake', price: 50.0, type: 3 },
  { id: 16, name: 'Icecream cake', price: 65.0, type: 3 },
  { id: 17, name: 'Apple cake', price: 55.0, type: 3 },
  { id: 18, name: 'Coffee cake', price: 50.0, type: 3 },
  { id: 19, name: 'Orange cake', price: 55.0, type: 3 },
  { id: 20, name: 'Strawberry cake', price: 70.0, type: 3 },
  { id: 21, name: 'Blueberry cake', price: 70.0, type: 3 },
  { id: 22, name: 'Lemon cake', price: 55.0, type: 3 },
  { id: 23, name: 'Mango cake', price: 65.0, type: 3 }
]

const tab = ref(1)
const selected = (p: Product) => {
  console.log('ProductView' + p)
  receiptStore.addReceiptItem(p)
  nextTick(() => {
    if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
  })
}
const clearOrder = function () {
  receiptStore.clear()
}
const showReceipt = function () {
  receiptStore.showReceiptDialog()
}

const divReceiptItems = ref<HTMLElement | null>(null)
</script>

<template>
  <v-container class="font">
    <v-row>
      <v-col cols="12" md="6" class="bgc">
        <v-sheet min-width="300" max-width="600" height="805">
          <v-tabs v-model="tab" color="brown" align-tabs="center">
            <v-tab :value="1">Baverage</v-tab>
            <v-tab :value="2">Snack</v-tab>
            <v-tab :value="3">Cake</v-tab>
          </v-tabs>
          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList :products="products1 as any" @selected-product="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList :products="products2 as any" @selected-product="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList :products="products3 as any" @selected-product="selected"></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>

      <v-divider vertical></v-divider>

      <v-col cols="12" md="6" class="bgc">
        <v-container style="padding: 0">
          <v-row>
            <v-col cols="12">
              <div ref="divReceiptItems" height="300" class="overflow-auto">
                <v-sheet min-width="300" max-width="600" height="300">
                  <ReceiptDetailTable></ReceiptDetailTable>
                </v-sheet>
              </div>
            </v-col>
            <v-col cols="12">
              <v-sheet min-width="300" max-width="600" height="50">
                <MemberCard></MemberCard>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <div ref="divReceiptItems" height="255">
                <v-sheet min-width="300" max-width="600" height="250">
                  <ReceiptCard></ReceiptCard>
                </v-sheet>
              </div>
            </v-col>
            <v-col cols="12">
              <v-sheet min-width="300" max-width="600" height="1">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <v-btn block rounded="xl" size="x-large" color="red" @click="clearOrder"
                        >Cancel</v-btn
                      >
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-btn block rounded="xl" color="green" size="x-large" @click="showReceipt"
                        >Process</v-btn
                      >
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
  <ErrorDialog></ErrorDialog>
  <ErrorCashDialog></ErrorCashDialog>
  <QrCodeDialog></QrCodeDialog>
  <ReceiptDialogVue></ReceiptDialogVue>
</template>

<style scoped>
.font {
  font-family: 'Kanit';
}
</style>
